﻿<EditForm OnValidSubmit="OnValidSubmit" Model="Form">
    <FluentValidator></FluentValidator>
    <div class="mb-3">
        <label for="name">Name</label>
        <InputText id="name" class="form-control" Value="@Form.Name" ValueExpression="@(() => Form.Name)" ValueChanged="OnNameChanged"></InputText>
    </div>
    <div class="mb-3">
        <label for="email">Email</label>
        <InputText id="email" class="form-control" Value="@Form.Email" ValueExpression="@(() => Form.Email)" ValueChanged="OnEmailChanged"></InputText>
    </div>
    <div>
        <ValidationSummary></ValidationSummary>
    </div>
    <div class="mb-3">
        <button class="btn btn-primary" type="submit">Submit</button>
    </div>
</EditForm>

@code {
    [Parameter]
    public EventCallback<CustomerCreateEditFormModel> OnSubmit { set; get; }

    [Parameter]
    public CustomerCreateEditFormModel Form { set; get; } = new CustomerCreateEditFormModel();

    [Parameter]
    public EventCallback<CustomerCreateEditFormModel> FormChanged { set; get; }

    async Task OnNameChanged(string value)
    {
        Form.Name = value;
        await FormChanged.InvokeAsync(Form);
    }

    void OnEmailChanged(string value)
    {
        Form.Email = value;
        FormChanged.InvokeAsync(Form);
    }

    public async Task OnValidSubmit()
    {
        await OnSubmit.InvokeAsync(Form);
    }
}
